//+----------------------------------------------------------------------+
//|                                                 WBAMAONGOING.mq4     |
//|                                             Copyright  2007, WB     |
//|                                                                      |
//+----------------------------------------------------------------------+

#property copyright "Copyright 2007,PIPSQUEAK2,IGORAD,CODERS GURU,WB"
#property link      ""
      
//+----------------------------------------------------------------------+
//| Declare our variables                                                |
//+----------------------------------------------------------------------+      

extern double    TakeProfit=1000;    //User can changes at run time
extern double    Lots=0.1;           //User can change at run time
bool             sellsig,buysig;     //Buy/Sell from customer indicator
int              cnt, ticket, total; //Used to manage orders

//+----------------------------------------------------------------------+
//| Expert initialization function                                       |
//+----------------------------------------------------------------------+

      int init(){return(0);}

//+----------------------------------------------------------------------+
//| expert deinitialization function                                     |
//+----------------------------------------------------------------------+

      int deinit(){return(0);}

//+----------------------------------------------------------------------+
//| expert start function                                                |
//+----------------------------------------------------------------------+
      int start()
{
      total  = OrdersTotal(); 

      if(total < 1) 
{
//+----------------------------------------------------------------------+
//| Read the parameters we need from the custom indicator                |
//+----------------------------------------------------------------------+

      double aq0=iCustom(NULL,0,"WBAMAIndicator",1,0);//Aqua going up
      double rd0=iCustom(NULL,0,"WBAMAIndicator",1,0);//Red going down
      double aq1=iCustom(NULL,0,"WBAMAIndicator",2,1);//Aqua going up
      double rd1=iCustom(NULL,0,"WBAMAIndicator",2,1);//Red going down

//+----------------------------------------------------------------------+
//|  Determine the opportunity to open/close buys and sells from the     |
//|  custom indicator.                                                   |
//+----------------------------------------------------------------------+

      if(aq0<rd1){sellsig=false;buysig=true;}         //Cover every
      if(rd0<aq1){buysig=false;sellsig=true;}         //possible
      if(aq0>rd1){sellsig=true;buysig=false;}         //buy/sell
      if(rd0>aq1){buysig=true;sellsig=false;}         //configuration

//+---------------------------------------------------------------------+
//|  Sanity check for WB to make sure we are getting the buy/sell       |
//|  signals from the custom indicator                                  |
//+---------------------------------------------------------------------+

      Print("Buysig = ",buysig, " Sellsig = ",sellsig);

//+---------------------------------------------------------------------+
//|  Figure out which order should be placed - buy or not?              |
//+---------------------------------------------------------------------+

      if (buysig==true) //If true, keep going:
   
      {ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"My EA",12345,0,Green);//Send a buy order
      
      if(ticket>0)      // If an order has been placed, keep going:
      
      {if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());} //Output the order or,
      
      else Print("Error opening BUY order : ",GetLastError()); //if there is an error let us know what it is
      
      return(0);}       //Exit
      
//+---------------------------------------------------------------------+
//|  Figure out which order should be placed - sell or not?             |
//+---------------------------------------------------------------------+

      if (sellsig == true)
      {ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"My EA",12345,0,Red);//Send a sell order
     
      if(ticket>0)      // If an order has been placed, keep going:
      
      {if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());} //Output the order or,
       
      else Print("Error opening SELL order : ",GetLastError()); //if there is an error let us know what it is
      return(0);}        //Exit
   
return(0);}//Go back to start

//+---------------------------------------------------------------------+
//|  Close open orders routine                                          |
//+---------------------------------------------------------------------+

      for(cnt=0;cnt<total;cnt++)//Loop, counter increments by total # or Order
      {OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())

      {if(OrderType()==OP_BUY)// if the order is a buy
      
      {if (buysig == false)//if the buy signal is false

      {OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); //then close the buy order
      return(0);} //Exit
      }}
      
      else //if it's not a buy order, then continue here for a short
     
      {if (buysig == true)//If the buy signal is true, close the short
      {OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
      return(0);} //Exit
      }}
               
      return(0);}//Exit

//+---------------------------------------------------------------------+
//|   End of program                                                    |
//+---------------------------------------------------------------------+